#include <iostream>
#include <map>
#include <vector>
#include <set>

#define int long long
using namespace std;
const int mod = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a;
    for (int i = 0; i < m; ++i) {
        int x;
        cin >> x;
        a.push_back(x);
    }
    vector<vector<int>> dp(n + 1, vector<int>(2));
    dp[1][0] = 1;
    dp[1][1] = 1;
    for (int i = 2; i < n + 1; ++i) {
        dp[i][0] = dp[i - 1][0] + dp[i - 1][1];
        dp[i][0] %= mod;
        for (int j = i - a[1] + 1; j >= 1; --j) {
            dp[i][1] += dp[j][1];
            dp[i][i] %= mod;
        }
    }
    cout << (dp[n][0] + dp[n][1]) % mod;
}
/*
6 4
1 4 6 5 2 3
3 1
2 2
6 3
4 3
 */