#include <iostream>
#include <map>
#include <vector>
#include <set>

#define int long long
using namespace std;
const int mod = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a;
    for (int i = 0; i < m; ++i) {
        int x;
        cin >> x;
        a.push_back(x);
    }
    vector<int> dp(n + 1, 0);
    for (int i = 0; i < a[1]; ++i) {
        dp[i] = 1;
    }
    for (int i = 2; i < n + 1; ++i) {
        for (int j = i - a[1]; j >= 0; --j) {
            dp[i] += dp[j];
            dp[i] %= mod;
        }
    }
    int sum = 0;
    for (int i = 0; i < n + 1; ++i) {
        sum += dp[i];
        sum %= mod;
    }
    cout << sum;
}
/*
6 4
1 4 6 5 2 3
3 1
2 2
6 3
4 3
 */