#include <iostream>
#include <map>
#include <vector>
#include <set>

using namespace std;
const int mod = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    map<pair<int, int>, int> ans;
    for (int i = 0; i < n; ++i) {
        ans[{i, 1}]++;
        vector<bool> used(n, false);
        used[i] = true;
        set<pair<int, int>> s;
        if (i > 0) {
            s.insert({a[i - 1], i - 1});
        }
        if (i < n - 1) {
            s.insert({a[i + 1], i + 1});
        }
        for (int j = 2; j <= n; ++j) {
            auto x = *s.begin();
            s.erase(s.begin());
            ans[{x.second, j}]++;
            used[x.second] = true;
            if (x.second > 0 && !used[x.second - 1]) {
                s.insert({a[x.second - 1], x.second - 1});
            }
            if (x.second < n - 1 && !used[x.second + 1]) {
                s.insert({a[x.second + 1], x.second + 1});
            }
        }
    }
    while (q--) {
        int p, k;
        cin >> p >> k;
        p--;
        cout << ans[{p, k}] << "\n";
    }
}
/*
6 4
1 4 6 5 2 3
3 1
2 2
6 3
4 3
 */